#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	freeradius
Version		:	3.2.6
Release		:	17.2.60.rel%{?dist}
Summary		:	High-performance and highly configurable free RADIUS server

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPL-2.0-or-later
URL		:	https://github.com/FreeRADIUS/freeradius-server

Source0		:	%{name}-server-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	autoconf
BuildRequires	:	gcc
BuildRequires	:	make
BuildRequires	:	json-c-devel
BuildRequires	:	krb5-devel
BuildRequires	:	krb5-server-ldap
BuildRequires	:	libpcap-devel
BuildRequires	:	mariadb
BuildRequires	:	openldap-devel
BuildRequires	:	openssl-devel
BuildRequires	:	postgresql-server-devel
BuildRequires	:	talloc-devel
BuildRequires	:	unixODBC-devel

#-----------------------------------------------------------------------------
%description
The FreeRADIUS Server Project is a high performance
and highly configurable multi-protocol policy server,
supporting RADIUS, DHCPv4 DHCPv6, DNS, TACACS+ and VMPS.
It is available under the terms of the GNU GPLv2.
Using RADIUS allows authentication and authorization for
a network to be centralized, and minimizes the number of
changes that have to be done when adding or deleting
new users to a network.

FreeRADIUS can authenticate users on systems such as 802.1x
(WiFi), dialup, PPPoE, VPN's, VoIP, and many others.
It supports back-end databases such as MySQL, PostgreSQL,
Oracle, Microsoft Active Directory, Apache Cassandra, Redis,
OpenLDAP, and many more. It is used daily to authenticate the
Internet access for hundreds of millions of people, in sites
ranging from 10 to 10 million+ users.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)

#init script
%{_sysconfdir}/rc.d/init.d/radiusd

#configuration
%{_sysconfdir}/raddb/

#binaries
%{_bindir}/dhcpclient
%{_bindir}/map_unit
%{_bindir}/rad_counter
%{_bindir}/radattr
%{_bindir}/radclient
%{_bindir}/radcrypt
%{_bindir}/radeapclient
%{_bindir}/radlast
%{_bindir}/radsecret
%{_bindir}/radsniff
%{_bindir}/radsqlrelay
%{_bindir}/radtest
%{_bindir}/radwho
%{_bindir}/radzap
%{_bindir}/rlm_ippool_tool
%{_bindir}/rlm_sqlippool_tool
%{_bindir}/smbencrypt

%{_sbindir}/checkrad
%{_sbindir}/raddebug
%{_sbindir}/radiusd
%{_sbindir}/radmin
%{_sbindir}/rc.radiusd

# libs
%attr(755,root,root) %{_libdir}/%{name}/lib*.so

%{_libdir}/%{name}/proto_dhcp.so
%{_libdir}/%{name}/proto_vmps.so
%{_libdir}/%{name}/rlm_always.so
%{_libdir}/%{name}/rlm_attr_filter.so
%{_libdir}/%{name}/rlm_cache.so
%{_libdir}/%{name}/rlm_cache_rbtree.so
%{_libdir}/%{name}/rlm_chap.so
%{_libdir}/%{name}/rlm_counter.so
%{_libdir}/%{name}/rlm_date.so
%{_libdir}/%{name}/rlm_detail.so
%{_libdir}/%{name}/rlm_dhcp.so
%{_libdir}/%{name}/rlm_digest.so
%{_libdir}/%{name}/rlm_dynamic_clients.so
%{_libdir}/%{name}/rlm_eap.so
%{_libdir}/%{name}/rlm_eap_fast.so
%{_libdir}/%{name}/rlm_eap_gtc.so
%{_libdir}/%{name}/rlm_eap_md5.so
%{_libdir}/%{name}/rlm_eap_mschapv2.so
%{_libdir}/%{name}/rlm_eap_peap.so
%{_libdir}/%{name}/rlm_eap_pwd.so
%{_libdir}/%{name}/rlm_eap_sim.so
%{_libdir}/%{name}/rlm_eap_tls.so
%{_libdir}/%{name}/rlm_eap_ttls.so
%{_libdir}/%{name}/rlm_exec.so
%{_libdir}/%{name}/rlm_expiration.so
%{_libdir}/%{name}/rlm_expr.so
%{_libdir}/%{name}/rlm_files.so
%{_libdir}/%{name}/rlm_ippool.so
%{_libdir}/%{name}/rlm_json.so
%{_libdir}/%{name}/rlm_krb5.so
%{_libdir}/%{name}/rlm_linelog.so
%{_libdir}/%{name}/rlm_ldap.so
%{_libdir}/%{name}/rlm_logintime.so
%{_libdir}/%{name}/rlm_mschap.so
%{_libdir}/%{name}/rlm_pam.so
%{_libdir}/%{name}/rlm_pap.so
%{_libdir}/%{name}/rlm_passwd.so
%{_libdir}/%{name}/rlm_perl.so
%{_libdir}/%{name}/rlm_preprocess.so
%{_libdir}/%{name}/rlm_python3.so
%{_libdir}/%{name}/rlm_radutmp.so
%{_libdir}/%{name}/rlm_realm.so
%{_libdir}/%{name}/rlm_replicate.so
%{_libdir}/%{name}/rlm_rest.so
%{_libdir}/%{name}/rlm_soh.so
%{_libdir}/%{name}/rlm_sometimes.so
%{_libdir}/%{name}/rlm_sql.so
%{_libdir}/%{name}/rlm_sqlcounter.so
%{_libdir}/%{name}/rlm_sqlippool.so
%{_libdir}/%{name}/rlm_sql_map.so
%{_libdir}/%{name}/rlm_sql_mysql.so
%{_libdir}/%{name}/rlm_sql_null.so
%{_libdir}/%{name}/rlm_sql_postgresql.so
%{_libdir}/%{name}/rlm_sql_sqlite.so
%{_libdir}/%{name}/rlm_sql_unixodbc.so
%{_libdir}/%{name}/rlm_test.so
%{_libdir}/%{name}/rlm_totp.so
%{_libdir}/%{name}/rlm_unix.so
%{_libdir}/%{name}/rlm_unpack.so
%{_libdir}/%{name}/rlm_utf8.so
%{_libdir}/%{name}/rlm_wimax.so
%{_libdir}/%{name}/rlm_yubikey.so
%{_libdir}/%{name}/rlm_dpsk.so
%{_libdir}/%{name}/rlm_eap_teap.so

# dictionaries
%dir %attr(755,root,root) %{_datadir}/%{name}/
%{_datadir}/%{name}/dictionary
%{_datadir}/%{name}/dictionary.*

# main man pages
%{_mandir}/man5/clients.conf.5.gz
%{_mandir}/man5/dictionary.5.gz
%{_mandir}/man5/radiusd.conf.5.gz
%{_mandir}/man5/radrelay.conf.5.gz
%{_mandir}/man5/rlm_always.5.gz
%{_mandir}/man5/rlm_attr_filter.5.gz
%{_mandir}/man5/rlm_chap.5.gz
%{_mandir}/man5/rlm_counter.5.gz
%{_mandir}/man5/rlm_detail.5.gz
%{_mandir}/man5/rlm_digest.5.gz
%{_mandir}/man5/rlm_expr.5.gz
%{_mandir}/man5/rlm_files.5.gz
%{_mandir}/man5/rlm_idn.5.gz
%{_mandir}/man5/rlm_mschap.5.gz
%{_mandir}/man5/rlm_pap.5.gz
%{_mandir}/man5/rlm_passwd.5.gz
%{_mandir}/man5/rlm_realm.5.gz
%{_mandir}/man5/rlm_sql.5.gz
%{_mandir}/man5/rlm_unbound.5.gz
%{_mandir}/man5/rlm_unix.5.gz
%{_mandir}/man5/unlang.5.gz
%{_mandir}/man5/users.5.gz
%{_mandir}/man8/raddebug.8.gz
%{_mandir}/man8/radiusd.8.gz
%{_mandir}/man8/radmin.8.gz
%{_mandir}/man8/radrelay.8.gz
%{_mandir}/man8/rlm_sqlippool_tool.8.gz

#-----------------------------------------------------------------------------
%preun
if [ "$1" = 0 ]; then
  %{_initrddir}/radiusd stop > /dev/null 2>&1 || :
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  %{_sbindir}/chkconfig --del radiusd
  %{_sbindir}/userdel %{name}
  fi

%pre
if [ ! "$(getent passwd %{name})" ]; then
  %{_sbindir}/useradd 				\
	-r					\
	-c "%{name} daemon"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g root					\
	-s /bin/bash				\
	-d %{_var}/spool/%{name}		\
	%{name}
  fi
%{_sbindir}/chkconfig --add radiusd

#=============================================================================
%package		devel
Summary		:	Development files for '%{name}'

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}
Requires	:	%{name}-doc	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/*.h

#=============================================================================
%package		utils
Summary		:	Utilities for analyzing and setting file capabilities

#-----------------------------------------------------------------------------
Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		utils

#-----------------------------------------------------------------------------
%files			utils
%defattr(-,root,root,-)
%{_defaultdocdir}/%{name}/rfc/*.txt
%{_defaultdocdir}/%{name}/schemas/

# utils man pages
%{_mandir}/man1/radclient.1.gz
%{_mandir}/man1/radeapclient.1.gz
%{_mandir}/man1/radlast.1.gz
%{_mandir}/man1/radtest.1.gz
%{_mandir}/man1/radwho.1.gz
%{_mandir}/man1/radzap.1.gz
%{_mandir}/man1/rad_counter.1.gz
%{_mandir}/man1/smbencrypt.1.gz
%{_mandir}/man1/dhcpclient.1.gz
%{_mandir}/man5/checkrad.5.gz
%{_mandir}/man8/radcrypt.8.gz
%{_mandir}/man8/radsniff.8.gz
%{_mandir}/man8/radsqlrelay.8.gz
%{_mandir}/man8/rlm_ippool_tool.8.gz

#=============================================================================
%package		doc
Summary		:	FreeRADIUS documentation


#-----------------------------------------------------------------------------
%description		doc
All documentation supplied by the FreeRADIUS project
is included in this package.

#-----------------------------------------------------------------------------
%files			doc
%defattr(-,root,root,-)
%{_defaultdocdir}/%{name}/

#=============================================================================
%prep
%setup -q -n %{name}-server-%{version}
tar xf %{SOURCE1}

#-----------------------------------------------------------------------------
#building application
%build

./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}/%{name}			\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-reproducible-builds			\
	--with-rlm_python3				\
	--without-rlm_python 				\
	--without-systemd 				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{_smp_mflags}					\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	R=%{buildroot}					\
	install

#installing init file
%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/
%{__cp} -a						\
	%{name}-ok_addon/radiusd.init			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/radiusd

#To remove libtool library and static library
find 							\
	%{buildroot}%{_libdir}				\
	\(						\
		 -name \*.la				\
		 -o					\
		 -name \*.a				\
	 \)						\
	-delete

#-----------------------------------------------------------------------------
%changelog
